/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include "../std/visitor.hpp"
#include "AutomatonBase.h"

namespace automaton {

/**
 * Wrapper around automata.
 */
class Automaton {
protected:
	AutomatonBase* automaton;
public:
	explicit Automaton(const AutomatonBase& automaton);
	explicit Automaton(AutomatonBase&& automaton);
	Automaton(const Automaton& other);
	Automaton(Automaton&&) noexcept;
	Automaton& operator=(const Automaton& other);
	Automaton& operator=(Automaton&& other) noexcept;
	virtual ~Automaton() noexcept;

	const AutomatonBase& getAutomaton() const;
	AutomatonBase& getAutomaton();

	void setAutomaton(const AutomatonBase& automaton);
	void setAutomaton(AutomatonBase&& automaton);
	
	bool operator!=(const Automaton& other) const;

	bool operator==(const Automaton& other) const;

	friend std::ostream& operator<<(std::ostream& os, const Automaton& automaton);
};

} /* namespace automaton */

#endif /* AUTOMATON_H_ */

